<?php
/*
	Copyright(c) 2010 Shift Tech Inc. All Rights Reserved.
 	http://www.shift-tech.jp/
*/
require_once (LIB_PATH.'/common/unitCommon.php');
require_once (LIB_PATH.'/common/imgmngrDB.php');

class extTtlTxtImg extends unitCommon
{
	//------ ユニット毎に必ず設定しなくてはならない変数 -------//
	var $_table = "extunit_ttltxtimg"; 			//公開用テーブル名
	var $_tmptable = "extunit_ttltxtimg_tmp"; //下書き用テーブル名
	var $columns = array(
					array("column"=>"pageu_code","conv"=>"n","tags"=>false),		//
					array("column"=>"ttltxig_img","conv"=>"a","tags"=>false),		//ファイル名
					array("column"=>"ttltxig_img_sp","conv"=>"a","tags"=>false),		//ファイル名
					array("column"=>"ttltxig_alt","conv"=>"KV","tags"=>false),		//ALT
					array("column"=>"ttltxig_cap","conv"=>"KV","tags"=>false),		//キャプション
					array("column"=>"ttltxig_clc_flg","conv"=>"n","tags"=>false),	//クリック時の動作
					array("column"=>"ttltxig_ttl","conv"=>"KV","tags"=>false),		//タイトル
					array("column"=>"ttltxig_txt","conv"=>"KV","tags"=>true),		//内容
					array("column"=>"ttltxig_lnk_url","conv"=>"a","tags"=>false),	//リンク先URL
					array("column"=>"ttltxig_lnk_flg","conv"=>"n","tags"=>false),	//リンク方法
					array("column"=>"ttltxig_lnk_txt","conv"=>"KV","tags"=>false),	//リンクテキスト
					array("column"=>"bg_color","conv"=>"n","tags"=>false),			//背景色
					array("column"=>"bdr_type","conv"=>"n","tags"=>false),			//枠線
					array("column"=>"btm_padding","conv"=>"n","tags"=>false),		//下方スペース
					array("column"=>"bg_color_sp","conv"=>"n","tags"=>false),		//背景色
					array("column"=>"bdr_type_sp","conv"=>"n","tags"=>false),		//枠線
					array("column"=>"btm_padding_sp","conv"=>"n","tags"=>false),		//下方スペース
					array("column"=>"use_sp_flg","conv"=>"n","tags"=>false)		//スマホ表示
					);
	var $jflg = array(1=>" target=\"_blank\"", 2=>"", 3=>" target=\"_top\"");
	var $_data = array();

	function extTtlTxtImg()
	{
		$this->__construct();
	}

	function __construct()
	{
		unitCommon::__construct();
	}

	//出力データセット処理（必須）
	function setDisplayData() {
		$this->_data = $this->getDetail();
		if ($this->_data) {
			if(defined("SP_FLG") && SP_FLG == SP_FLG_CODE){
				if($this->_data['ttltxig_img_sp']) $this->_data['ttltxig_img'] = $this->_data['ttltxig_img_sp'];
				$this->_data['bg_color'] = $this->_data['bg_color_sp'];
				$this->_data['bdr_type'] = $this->_data['bdr_type_sp'];
				$this->_data['btm_padding'] = $this->_data['btm_padding_sp'];
			}

			//画像パス
			$this->_data['path'] = UNITS_IMG_PATH.$this->_data['ttltxig_img'];

			//画像リンクタグ
			$this->_data['a1'] = '';
			$this->_data['a2'] = '';
			if ($this->_data['ttltxig_clc_flg']!=0) {
				switch ($this->_data['ttltxig_clc_flg']) {
					case 1:
						$this->_data['target'] = " target=\"_blank\"";
						if(is_file(BASE_PATH.UNITS_IMG_PATH.$this->_data['ttltxig_img'])) {
							list($wth, $hgt, $type, $attr) = getimagesize(BASE_PATH.UNITS_IMG_PATH.$this->_data['ttltxig_img']);
						}
						$this->_data['a1'] = "<a href=\"javascript:void(0);\" onClick=\"window.open('".$this->_current_topurl.$this->_data['path']."', null, 'width=".$wth.",height=".$hgt."');\">";
						break;
					case 2:
						$this->_data['a1'] = "<a href=\"".$this->_current_topurl.$this->_data['path']."\" rel=\"lightbox[ligthbox]\"".$this->jflg[$this->_data['ttltxig_lnk_flg']].">";
						break;
					case 3:
						$this->_data['a1'] = "<a href=\"".$this->_data['ttltxig_lnk_url']."\"".$this->jflg[$this->_data['ttltxig_lnk_flg']].">";

						break;
					default:
				}
				$this->_data['a2'] = '</a>';
			}

			$this->_data['target'] = $this->jflg[$this->_data['ttltxig_lnk_flg']];
		}
		return $this->_data;
	}

	/*
	 * DBより保存データ取得
	 * 改変可能
	 */
	function getDetail() {
		$sql = "select * from ".$this->getTbl()." where pageu_code = ?";

		if(isset($this->_pageu_code)&&is_numeric($this->_pageu_code)) {
			$result = $this->db->prepare($sql,$this->_pageu_code);
			if($result) {
				$rtn = $result->fetchRow(DB_FETCHMODE_ASSOC);
			}
		}
		return $rtn;
	}


	function setDefault()
	{
		$data = $this->getDetail();
		if(!$data){
			$data["ttltxig_clc_flg"] = 0;
		}
		$this->_form->setDefaults($data);
		if ($data['ttltxig_img']) {
			$this->_view->assign('image', BINGOTOPURL.UNITS_IMG_PATH.$data['ttltxig_img']);
		}
		if ($data['ttltxig_img_sp']) {
			$this->_view->assign('image_sp', BINGOTOPURL.UNITS_IMG_PATH.$data['ttltxig_img_sp']);
		}
	}

	//フォームエレメントの作成
	function setElements()
	{
		$this->_form->addElement('hidden','pageu_code', $this->_pageu_code,array("id"=>"pageu_code")); //ページコード
		$this->_form->addElement('hidden','ttltxig_img', null,array("id"=>"ttltxig_img"));
		$this->_form->addElement('hidden','ttltxig_img_sp', null,array("id"=>"ttltxig_img_sp"));
		$this->_form->addElement('file', 'picture', '');//画像アップ用ボタン
		$this->_form->addElement('text','ttltxig_alt', null, array('id'=>'ttltxig_alt','size'=>40,'maxlength' => 200));
		$this->_form->addElement('text','ttltxig_cap', null, array('id'=>'ttltxig_cap','size'=>40,'maxlength' => 200));
		$tmp = array();
		$tmp[] = $this->_form->createElement('radio', null, null, _gettext('B_P00420'), 0);
		$tmp[] = $this->_form->createElement('radio', null, null, _gettext('B_P00682'), 1);
		$tmp[] = $this->_form->createElement('radio', null, null, _gettext('B_P00683'), 2);
		$tmp[] = $this->_form->createElement('radio', null, null, _gettext('B_P00684'), 3);
		$this->_form->addGroup($tmp, 'ttltxig_clc_flg', array('id'=>'ttltxig_clc_flg'));
		$this->_form->addElement('text','ttltxig_ttl', null, array('id'=>'ttltxig_ttl','size'=>40,'maxlength' => 200));
		$this->_form->addElement('textarea','ttltxig_txt', null, array('id'=>'ttltxig_txt','rows'=>10));
		$this->_form->addElement('text','ttltxig_lnk_url', null, array('id'=>'ttltxig_lnk_url','size'=>40,'maxlength' => 200,'style'=>'ime-mode:disabled'));
		$sel01 =& $this->_form->addElement('select','ttltxig_lnk_flg', array('id'=>'ttltxig_lnk_flg'), null);
		$sel01->addOption(_gettext('B_P00659'), 1);
		$sel01->addOption(_gettext('B_P00660'), 2);
		$this->_form->addElement('text','ttltxig_lnk_txt', null, array('id'=>'ttltxig_lnk_txt','size'=>40,'maxlength' => 200));

		//表示中の画像サイズ
		$imgs_str = isset($_REQUEST["imgs"]) ? $_REQUEST["imgs"] : null;
		$this->_form->addElement('hidden','imgs', $imgs_str, array("id"=>"imgs"));

		$data = $this->getDetail();
		if(empty($data) || LICENSE::getMode()==1){
				$this->_form->addElement("hidden", "autoregister1", 1);
		}else{
			$this->_form->setDefaults(array("autoregister1"=>1));
			$this->_form->addElement("advcheckbox", "autoregister1", null, _gettext("B_P00940"), array(), array(0,1));
		}
	}

	//フォーム入力エラーチェックの設定
	function setRules()
	{
		$this->_form->applyFilter('__ALL__','trim');
		$this->_form->_submitValues = DataBase::ConvColumnVals($this->_form->_submitValues,$this->columns); //ルールに従った値変換、タグの除去
		$this->_form->setJsWarnings(_gettext('B_P00472'),'');
		$this->_form->addRule('pageu_code',_gettext('B_P00643'),'required',null,$this->erchk);
		$obj = $this->_form->getElement("ttltxig_img");
		if (!$obj->getValue()) {
			$this->_form->addRule('picture',_gettext('B_P00644'),'uploadedfile',null,'server');
		}
		$this->_form->addRule('picture',_gettext('B_P00636',MAX_FILE_SIZE/(1000*1000)),'maxfilesize',MAX_FILE_SIZE,null,'server');
		$this->_form->addRule('picture',_gettext('B_P00171'),'mimetype',array("image/pjpeg","image/jpeg","image/gif","image/x-png","image/png"));
		$this->_form->addRule('ttltxig_ttl',_gettext('B_P00663'),'required',null,$this->erchk);
		$this->_form->addRule('ttltxig_txt',_gettext('B_P00210'),'required',null,$this->erchk);
		//URL（入力がある場合のみチェック）
		$this->_form->registerRule('check_url', 'callback', 'check_url');
		$obj2 = $this->_form->getElement("ttltxig_lnk_url");
		if ($obj2->getValue()!='') {
			$this->_form->addRule( 'ttltxig_lnk_url', _gettext('B_P00645'), 'check_url',null,'server');
			$this->_form->addRule('ttltxig_lnk_url',_gettext('B_P00646'),'required',null,$this->erchk);
		} else {
			//画像クリック時の指定がリンクならURL必須
			$obj3 = $this->_form->getElement("ttltxig_clc_flg");
			if ($obj3->getValue()==3) {
				$this->_form->addRule('ttltxig_lnk_url',_gettext('B_P00646'),'required',null,$this->erchk);
			}
		}
		$this->_form->registerRule('check_tags', 'callback', 'check_tags');
		$this->_form->addRule('ttltxig_txt',_gettext('B_P00681'),'check_tags',null,$this->erchk);
	}

	//データ下書き保存処理
	function doSave($post)
	{
		//あらかじめ画像処理
		$result = null;
		$bimg = '';
		//既存データがあるか確認（画像削除用にも使用）
		$old_data = $this->getDetail();
		$record = null;
		foreach($this->columns as $val) {
			if($post[$val["column"]]!=null){
				$record[$val["column"]] = $post[$val["column"]];
			} else {
				$record[$val["column"]] = null;
			}
		}
		// ここでDBに登録する画像情報を公開用の画像情報に設定する
		// 画像を差し替えた場合（たとえ同じ画像でも）、数値が入ってくる為、これを判定条件とする
		if(is_numeric($record["ttltxig_img"])) {
			// ここでhidden属性（上記の数値に設定されたもの）を現在設定されている画像パスの状態にもどす
			// 前提：エラー時（画像以外の入力でエラーになった場合でも）は新しく選択したファイルが画面上から消えること（既存ファイルが選択されている状態に戻る）
			if(is_array($old_data)&& count($old_data)>0){
				$this->_form->updateElementAttr('ttltxig_img',array('value' => $old_data['ttltxig_img']));
			}
			$imgmngrDB = new imgmngrDB();
			$imgdata = $imgmngrDB->getImageFromCode($record["ttltxig_img"], UNITS_IMG_PATH, $record["pageu_code"], 1);
			if(isset($imgdata)){
				$data_path = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
				$img_path = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
				$record["ttltxig_img"] = array_pop(explode('/',$img_path)); //保存ファイル名取得
				$cpflg = true;
			}else{
				return _gettext('B_P00651');
			}
		}
		if(empty($record["ttltxig_img_sp"]) || $_REQUEST["autoregister1"] == 1) {
			if(is_numeric($tmp_img_sp)){
				$record["ttltxig_img_sp"] = $tmp_img_sp;
				// ここでhidden属性（上記の数値に設定されたもの）を現在設定されている画像パスの状態にもどす
				// 前提：エラー時（画像以外の入力でエラーになった場合でも）は新しく選択したファイルが画面上から消えること（既存ファイルが選択されている状態に戻る）
				if(is_array($old_data)&& count($old_data)>0){
					$this->_form->updateElementAttr('ttltxig_img_sp',array('value' => $old_data['ttltxig_img_sp']));
				}
				$imgmngrDB = new imgmngrDB();
				$imgdata = $imgmngrDB->getImageFromCode($record["ttltxig_img_sp"], UNITS_IMG_PATH, $record["pageu_code"], 1);
				if(isset($imgdata)){
					$data_path1_sp = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
					$img_path1_sp = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
					$record["ttltxig_img_sp"] = array_pop(explode('/',$img_path1_sp)); //保存ファイル名取得
					$cpflg1_sp = true;
				}else{
					$errstr = _gettext('B_P00701');
				}
			}else{
				$record["ttltxig_img_sp"] = $record["ttltxig_img"];
			}
		}else if(is_numeric($record["ttltxig_img_sp"])) {
			// ここでhidden属性（上記の数値に設定されたもの）を現在設定されている画像パスの状態にもどす
			// 前提：エラー時（画像以外の入力でエラーになった場合でも）は新しく選択したファイルが画面上から消えること（既存ファイルが選択されている状態に戻る）
			if(is_array($old_data)&& count($old_data)>0){
				$this->_form->updateElementAttr('ttltxig_img_sp',array('value' => $old_data['ttltxig_img_sp']));
			}
			$imgmngrDB = new imgmngrDB();
			$imgdata = $imgmngrDB->getImageFromCode($record["ttltxig_img_sp"], UNITS_IMG_PATH, $record["pageu_code"], 1);
			if(isset($imgdata)){
				$data_path1_sp = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
				$img_path1_sp = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
				$record["ttltxig_img_sp"] = array_pop(explode('/',$img_path1_sp)); //保存ファイル名取得
				$cpflg1_sp = true;
			}else{
				$errstr = _gettext('B_P00701');
			}
		}
		//リンクURL指定なければ関連する項目はクリア
		if (!$record["ttltxig_lnk_url"]) {
			$record["ttltxig_lnk_flg"] = 1;
			$record["ttltxig_lnk_txt"] = '';
		}

		//既存データがあるか確認
		$old_data = $this->getDetail();
		$this->db->query('BEGIN');
		//保存処理開始
		if(is_array($old_data)&& count($old_data)>0) {
			//更新
			if(!$this->db->update($this->getTbl(),$record, "pageu_code=".$record["pageu_code"])) {
				$this->db->query('ROLLBACK');
				return _gettext('B_P00209');
			}
		} else {
			//新規
			if(!$this->db->insert($this->getTbl(),$record)) {
				$this->db->query('ROLLBACK');
				return _gettext('B_P00209');
			}
		}

		// saas
		$fsize = array();
		if($cpflg) $fsize[] = array('size' => filesize(BASE_PATH.$data_path));
		if($cpflg1_sp) $fsize[] = array('size' => filesize(BASE_PATH.$data_path1_sp));
		if (count($fsize)>0 && !commonFile::chkSaveFiles($fsize)) {
			$this->db->query('ROLLBACK');
			return _gettext('B_P00281');
		}

		// ここでファイルのコピーを行う
		if($cpflg) {
			if(!@copy(BASE_PATH.$data_path, BASE_PATH.$img_path)){
				$this->db->query('ROLLBACK');
				return _gettext('B_P00650');
			} else {
				@chmod(BASE_PATH.$img_path, 0666);
			}
		}
		if($cpflg1_sp) {
			//スマホ用はリサイズして保存
			if(!commonFIle::ImgResize(BASE_PATH.$data_path1_sp, BASE_PATH.$img_path1_sp, $new_w=DEFAULT_SPIMG_W*2, null, false)){
				$this->db->query('ROLLBACK');
				return _gettext('B_P00650');
			} else {
				@chmod(BASE_PATH.$img_path1_sp, 0666);
			}
		}
		$this->db->query('COMMIT');
		return null;
	}
}
?>